tex_sit = "bobuck sit"
tex_speak = "bobuck speak"
tex_happy = "bobuck happy"
tex_sad = "bobuck sad"

patron = world["Charles Bobuck"]

state = SimpleNamespace()
state.steps = 0
state.tex_emote = None

# Public

def neutral():
	state.tex_emote = None
	
def happy():
	state.tex_emote = tex_happy
	
def sad():
	state.tex_emote = tex_sad

# Private

def step():
	if state.tex_emote is None:
		if (patron.vocalizing):
			with_bobucks(set_texture(tex_speak))
		else:
			with_bobucks(set_texture(tex_sit))
	else:
		with_bobucks(set_texture(state.tex_emote))

	if (state.steps >= 15):
		with_bobucks(toggle_subimage)
		state.steps = 0
	else:
		state.steps += 1
		
def toggle_subimage(bobuck):
	bobuck.subimage.set((bobuck.subimage.get() + 1) % 2)

def set_texture(texture_name):
	return lambda bobuck : bobuck.texture.set(texture_name)
	
def with_bobucks(action):
	action(world["BobuckOverworldDecal"])
	action(world["BobuckTalkDecal"])