from audio import Audio
from world import Global

from hubol.entity import HubolEntity
from hubol.util import AudacityLabelProcessor

from owg.util.editor2d.entity import Ephemeral
from owg.util.euclidian import Compass
from owg.util.euclidian import V2D

from owg.util.opengl import ColorF
from owg.util.opengl import BlendMode
from owg.util.opengl import TextureLib

from bogus.core.BogusCore import egl

from java.lang.Math import random

jiggle_interval_frames = 3

jiggle_offset = V2D()

def set_lyric_text(lyric):
	lyric_text_renderer.set_text(lyric.text)
	
def clear_lyric_text():
	lyric_text_renderer.clear_text()
	
def jiggle(alarm):
	jiggle_offset.set(V2D.unitRandom().multiply(random() * 5))
	alarm.restart(jiggle_interval_frames)
	
def lyric_text_renderer_pos():
	return this.state.pos.clone().add(jiggle_offset)
	
class TextRenderer(HubolEntity, Ephemeral):
	def __init__(self, depth):
		HubolEntity.__init__(self, list, depth)
		self.text = ""
		
	def set_text(self, text):
		self.text = text
		
	def clear_text(self):
		self.text = ""

	def render(self):
		if len(self.text) == 0:
			return
		
		pos = lyric_text_renderer_pos()
		x = int(pos.x())
		y = int(pos.y())
		
		font = game.eventFontRenderer;
		
		width = font.getStringWidth(self.text) + 20
		height = font.getStringHeight(self.text) + 12
		
		egl.setBlendMode(BlendMode.NORMAL)
		egl.enableTexture2D(TextureLib.tex("soft quad"), 0)
		egl.setColor(ColorF.BLACK.deriveAlpha(0.5))
		
		for i in range(2):
			egl.modelviewMatrix().push()
			egl.modelviewMatrix().translated(x, y, 0)
			if i == 0:
				egl.modelviewMatrix().translated(10, 10, 0)
			egl.modelviewMatrix().scaled(width / 2, height / 2, 1)
			egl.unitSquare.render()
			egl.modelviewMatrix().pop()
			
			egl.disableTexture()
			egl.setColor(ColorF.WHITE)
		
		font.render(egl, self.text, x, y, Compass.CENTER)
		
	def beginStep(self):
		pass
		
	def step(self):
		pass
		
alarm_restartable(jiggle).start(jiggle_interval_frames)
lyric_text_renderer = TextRenderer(-10)