from world import Global
from owg.util.Calc import choose

from collections import namedtuple

say = this.say
ask = this.ask
make_sing = this.makeSing
sleep = this.sleep
get_clip = this.getClip

bobuck = world["BobuckAnimator"]

Song = namedtuple('Song', 'before_play_song audio_file lyrics_file after_play_song')

def conversation():
	song = choose_song()
	play_song(song)

def gregg_intro():
	say("So this tune... I first saw this peculiar character on the plot of land where a certain former student of mine practices his drumming.")
	say("And usually I am not so judgemental, but I've got to say, this guy I saw... well... I'll let the tune speak for itself now.")
	
def gregg_outro():
	banger = "#banger"
	result = ask("Well... hopefully you managed to enjoy that. What do you say, is it a #banger or #not a banger?", banger, "#not")
	if result == banger:
		bobuck.happy()
		say("Ha! Perhaps this is the world's first #coprophagiac banger.")
		bobuck.neutral()
		say("I'm glad you got a kick out of it. Maybe I'll have something a little more \"taste\"ful for next time--oh I crack myself up!")
	else:
		bobuck.happy()
		say("Ha! Well that is quite alright! You know, not even my husband is the biggest fan of my music!")
		bobuck.neutral()
		say("Thank you for entertaining a codger like me. So you around, B!")

def drummer_intro():
	say("What can I say... this little tiny tune is about someone who brought us together!")
	say("I met him way back, after he dropped out of the university. He was desperate to find something to do with his hands to calm his anxiety.")
	say("I taught him the way, and if it weren't for that, you would have never met him either.")
	say("You ever heard of the \"butterfly effect\"?--it's pretty intellectual, so maybe not.")
	say("Anyhow... here's the tune.")
	
def drummer_outro():
	say("Little drumming man... Pretty catchy huh?")
	grade = ask("So let's do a bit of role-play here. If I were YOUR student, what grade would you give me for that little tune?", "A", "B", "C", "D", "F")
	if grade == "A":
		bobuck.happy()
		say("You're too kind, Bogus! I hate to be like this, but I kind of don't believe you.")
		bobuck.neutral()
		say("Anyhow, I appreciate it! Hopefully I'll be able to keep my GPA up!")
	elif grade == "B":
		improve = ask("Now that is a grade I can believe. If I may, can I ask what I could improve in the song to change my grade?", "Instruments.", "Lyrics.")
		if improve == "Instruments.":
			say("Eh, I'll admit that the instrumentation of the song is pretty minimalist. In fact, it is probably a bit too extreme.")
			say("Well, I'm noting your critique... I'll try and flesh out my other tunes a bit more.")
			bobuck.happy()
			say("Thank you for listening, B!")
			bobuck.neutral()
		else:
			say("Eh, I agree I guess. The lyrics are pretty repetitive--the subtlety is kind of lost when things are so repetitive.")
			say("I'm noting your critique, but no promises that I can produce a bunch of brilliant verses for my tiny tunes!")
			bobuck.happy()
			say("Oh, and thank you for listening, Bogus!")
			bobuck.neutral()
	elif grade == "C":
		say("Ah, a \"C\"--the age-old \"average\" grade.")
		say("I have to say, I don't think I necessarily believe that this song could deserve a \"C\".")
		bobuck.happy()
		say("But that's art, baby! Let's agree to disagree!")
		bobuck.neutral()
	elif grade == "D":
		say("A \"D\", huh? Now that is dangerously close to an \"F\"!")
		say("But to be honest, I realize my music is not for everyone. In fact it's usually only for myself.")
		bobuck.happy()
		say("That being said, I appreciate the \"D\"! Thanks, Bogus!")
		bobuck.neutral()
	else:
		say("An \"F\", huh?! You must be a real hater!")
		say("Eh, but then again, I realize my music is not for everyone. Come to think of it, it's usually only for myself!")
		say("Well, thanks for listening anyway, Bogus!")
		
def bogus_intro():
	ask("Well Bogus, it finally happened!", "What?")
	say("Well, I finally made a tiny tune about you! Here, take a listen!")
	
def bogus_outro():
	ask("Well, how was that? Did it tick all of your boxes?", "Yes.", "Absolutely.")
	bobuck.happy()
	say("I knew it! I kind of have your taste figured out by now!")
	bobuck.neutral()
	say("Not that I... you know, generally tailor my output to other people's taste. I'm my own audience.")
	say("As always, thank you for listening, B!")
		
gregg = Song(gregg_intro, "bobuck - on gregg.ogg", "greggs theme.txt", gregg_outro)
drummer = Song(drummer_intro, "bobuck - on drummer.ogg", "drummer.txt", drummer_outro)
bogus = Song(bogus_intro, "bobuck - on bogus.ogg", "bogus.txt", bogus_outro)
	
songs = [ gregg, drummer, bogus ]

def choose_song():
	for song in songs:
		if store.addFlag(song.audio_file):
			return song
	return choose(songs)
	
def play_song(song):
	song.before_play_song()
	zune.show()
	
	sing = make_sing(song.audio_file, song.lyrics_file, bobuck_song_player.set_lyric_text, bobuck_song_player.clear_lyric_text)
	if sing is None:
		say("Hm... looks like I'm having some technical difficulties...")
		say("Sorry Bogus, maybe next time!")
		zune.hide()
		sleep(0.25)
		return
	
	cafe_music_player.stop_music()
	playback_time_seconds = sing()
	sleep(playback_time_seconds)
	cafe_music_player.play_music()
	zune.hide()
	sleep(0.25)
	song.after_play_song()
	
def start():
	zune.setVisible(False)

cafe_music_player = world["MusicPlayer"]
bobuck_song_player = world["BobuckLyricsAnimator"]
zune = world["ZuneAnimator"]