from hubol.util.tex import VideoTexBuilder
from bogus.core.BogusCore import egl
from com.jogamp.opengl import GL

from world.Global import contentRelative

from mini.karaoke.intro import KaraokeBothSpawner

bobuck = world["BobuckAnimator"]

video = this.video
say = this.say
ask = this.ask
sleep = this.sleep
get_clip = this.getClip
photo = this.photo

zune = world["ZuneAnimator"]

def conversation():
	if store.addFlag("discuss leaving the residents"):
		discuss_leaving_the_residents()
	elif KaraokeBothSpawner.win.isAwarded():
		say("You know, Bogus, I'm still so impressed by your fabulous performance.")
		if store.addFlag("first time discussing performance"):
			bobuck.happy()
			say("You are quite the vocalist! You truly have found your voice! And your dance moves--simply magnificent!")
			
			borgus_killed = KaraokeBothSpawner.killedBorgus.isPresent()
			drummer_killed = KaraokeBothSpawner.killedDrummer.isPresent()
			both_killed = borgus_killed and drummer_killed
			one_killed = borgus_killed or drummer_killed
			
			if both_killed:
				say("And killing your bandmates--how performative!")
				bobuck.neutral()
				say("It's a shame we won't be able to get the band back together again! But such is life!")
				bobuck.happy()
				say("And despite the double homicide, I think I may have great potential as a touring manager!")
			elif one_killed:
				say("And killing your bandmate once the lights went down--how performative!")
				bobuck.neutral()
				if borgus_killed:
					say("You know, there are a lot of bands out there that don't have a guitarist. I don't see why you and Drummer can't continue on.")
					say("And let me say, if you are interested, I would be thrilled to be your tour manager!")
				else:
					say("You know, a lot of the young kids who go to these shows nowadays aren't even interested in dancing.")
					say("You get what I'm saying? You can get away without any percussion--without Drummer.")
					say("Maybe you and Borgus could still take the show on the road? And I would certainly love to be your tour manager!")
			else:
				say("Borgus is an exquisite guitarist--such triumphant tasters! And Drummer, well, we all know he was born to perform!")
				say("I'm just happy to have been involved, frankly!")
			
			sleep(0.2)
			Audio.play("bobuck think", None, 1, None, 1)
			sleep(1.2)
			
			bobuck.neutral()
			say("Well, thanks for checking in, B. I'll let you know if any great opportunities come up!")
		else:
			say("That reminds me! I met an awesome fan outside the venue that night!")
			photo("bobuck with fan.jpg", "Awesome fan")
			say("Yep, a worm fan--knew every single one of my albums by heart.")
			bobuck.sad()
			say("...It was kind of weird...")
			bobuck.happy()
			say("Anyway, I'm looking forward to your next big show! Maybe I can meet some more worm fans who know of my work.")
			bobuck.neutral()
	else:
		if store.addFlag("discuss management yearning"):
			discuss_management_yearning()
		elif store.addFlag("first performance proposal"):
			ask("OK Bogus, remember when I said I was interested in perhaps managing a band?", "Sure.", "No.")
			say("Well, I think I did a bit of a goof...")
			say("I told the owner of a local venue that I have a really good band, and well, one thing led to another and...")
			bobuck.sad()
			say("Well, here's the poster...")
			photo("show poster.png", "Cool Poster!")
			say("So, I'm a bit nervous... Because I lied, there is no band, you know?")
			bobuck.neutral()
			say("I'm pretty desperate... So, if you can find a vocalist, guitarist, and percussionist...")
			say("...Please let me know...")
			KaraokeBothSpawner.bobuckRequestedPerformers.add()
		else:
			ask("Oh Bogus, did you find a band to play at the show I foolishly booked?", "No.")
			bobuck.sad()
			say("I figured... No worries...")
			bobuck.neutral()
			say("Just keep your eyes peeled for me... My reputation is on the line, after all!")
				
def discuss_management_yearning():
	say("You know I think I've got that bug--the music bug. I think I want to get back in the music business.")
	say("But perhaps in a slightly different role than what I've been used to...")
	bobuck.happy()
	say("I'm thinking that managing a group would be fun, and kind of falls in line with my brand-new camp counselor lifestyle!")
	bobuck.neutral()
	say("I don't exactly expect anything to come out of it, it's just for fun...")
	
def discuss_leaving_the_residents():
	say("You know, Bogus, it wasn't all that long ago that I retired from composing and touring with The Residents.")
	bobuck.sad()
	say("After 44 years, there are certainly parts of that life that I miss... But it's in the past now. I'm just too decrepit to be exerting myself like that anymore.")
	bobuck.neutral()
	say("When I especially miss it, I've got a video on my Zune to remember my touring life by...")
	
	zune.show()
	sleep(0.2)
	play_reminisce_clip()
	sleep(0.5)
	zune.hide()
	sleep(0.3)
	
	say("We toured the world as Randy, Chuck, and Bob...")
	say("Yeah... \"Chuck\"...")
	
	say("Even after my retirement... I continue to bear the name that was created only to identify myself as a member of The Residents.")
	say("I'm stuck in this form. I'm in ego-limbo, baby. One foot in The Residents, one foot out.")
	say("I don't exactly expect to be completely freed from my association with The Residents... It just feels unpleasant to carry around an artifact of them...")
	say("I know, I know, it's not exactly relatable... Anyhow...")
	say("I'm hoping to treat my stay in Mundenmark as a sort-of summer camp. I'm going to learn all kinds of great, forgettable skills!")
	say("Maybe I'll really interfere with other people's lives and serve as a camp counselor. I could probably handle that.")
	bobuck.happy()
	ask("So, let me know if you require any counseling, Bogus!", "Sure thing!")
	
reminisce = world["BobuckReminisce"]

cafe_music_player = world["MusicPlayer"]

memories_video_tex_builder = (VideoTexBuilder(
	egl,
	contentRelative("videos/bobuck memories.mp4"),
	512,
	512)
	.setMinFilter(True)
	.setMagFilter(True))
	
def play_reminisce_clip():
	clip = get_clip(contentRelative("songs/bobuck reminisces.ogg"))
	if clip is None:
		return
	
	video_tex_entity = video(memories_video_tex_builder, 24)
	if video_tex_entity is not None:
		reminisce.on(video_tex_entity)
	cafe_music_player.stop_music()
	clip.play()
	sleep(38)
	cafe_music_player.play_music()
	reminisce.off()