from owg.util.Calc import fastSin, fastCos, PI
from java.util import Random
from java.lang.Math import abs, signum

random = Random()

class Fly:
	def __init__(self, h_amplitude, h_delta, h_method, v_amplitude, v_delta, v_method, prog, prog_delta, start_pos, decal):
		self.h_amplitude = h_amplitude
		self.h_delta = h_delta
		self.h_method = h_method
		self.v_amplitude = v_amplitude
		self.v_delta = v_delta
		self.v_method = v_method
		self.prog = prog
		self.prog_delta = prog_delta
		self.start_pos = start_pos
		self.decal = decal
		
	def step(self):
		self.prog = (self.prog + self.prog_delta) % 1.0
		prog = self.prog * PI * 2
		
		self.decal.state.pos.set(self.start_pos.clone()).add(self.h_method(prog * self.h_delta) * self.h_amplitude, self.v_method(prog * self.v_delta) * self.v_amplitude)
		
		scale = self.decal.state.scale
		xscale = signum(self.decal.state.pos.x() - self.start_pos.x())
		self.decal.setScale(abs(scale.x()) * xscale, scale.y())

def build_fly(decal):
	scale_radius = decal.state.scale.len()

	h_amplitude = (0.25 + random.nextFloat() * 0.75) * scale_radius * 1.5
	h_delta = 1
	h_method = fastSin if random.nextFloat() > 0.5 else fastCos

	v_amplitude = (0.25 + random.nextFloat() * 0.75) * random.nextFloat() * scale_radius
	v_delta = random.nextInt(3) + 1
	v_method = fastSin if random.nextFloat() > 0.5 else fastCos
	
	prog = random.nextFloat()
	prog_delta = 0.0175 + random.nextFloat() * 0.005
	
	start_pos = decal.state.pos.clone()
	return Fly(h_amplitude, h_delta, h_method, v_amplitude, v_delta, v_method, prog, prog_delta, start_pos, decal)

flies = map(build_fly, world["FlyDecals"])

def step():
	for fly in flies:
		fly.step()
	