tex_sit = "gregg sit"
tex_speak = "gregg speak"
tex_happy = "gregg happy"
tex_shocked = "gregg shocked"
tex_sad = "gregg sad"

phone_on_table = world["PhoneResting"]
phone_sit = world["PhoneSitting"]
phone_speak = world["PhoneTalking"]
phone_happy = world["PhoneShockedHappy"]
phone_shocked = world["PhoneShockedHappy"]
phone_sad = world["PhoneSitting"]
phones = [phone_on_table, phone_sit, phone_speak, phone_happy, phone_shocked, phone_sad]

tex_to_phone = {
tex_sit: phone_sit,
tex_speak: phone_speak,
tex_happy: phone_happy,
tex_shocked: phone_shocked,
tex_sad: phone_sad
}

patron = world["Gregg \"The Hungry\""]

state = SimpleNamespace()
state.show_phone = False
state.phone_held = False
state.steps = 0
state.tex_emote = None

# Public

def neutral():
	state.tex_emote = None
	
def happy():
	state.tex_emote = tex_happy
	
def shocked():
	state.tex_emote = tex_shocked
	
def sad():
	state.tex_emote = tex_sad

def show_phone():
	state.show_phone = True

def hide_phone():
	state.show_phone = False
	display_phone(None)
	
def hold_phone():
	state.show_phone = True
	state.phone_held = True
	
def drop_phone():
	state.show_phone = True
	state.phone_held = False
	
# Private
	
def step():
	if state.tex_emote is None:
		if (patron.vocalizing):
			with_greggs(set_texture(tex_speak))
			display_phone(phone_speak)
		else:
			with_greggs(set_texture(tex_sit))
			display_phone(phone_sit)
	else:
		with_greggs(set_texture(state.tex_emote))
		display_phone(tex_to_phone[state.tex_emote])

	if (state.steps >= 15):
		with_greggs(toggle_subimage)
		state.steps = 0
	else:
		state.steps += 1
		
def toggle_subimage(gregg):
	gregg.subimage.set((gregg.subimage.get() + 1) % 2)

def set_texture(texture_name):
	return lambda gregg : gregg.texture.set(texture_name)
	
def with_greggs(action):
	action(world["GreggOverworldDecal"])
	action(world["GreggTalkDecal"])

def display_phone(phone):
	for visible in phones:
		visible.setVisible(False)
		
	if not state.show_phone:
		return
		
	if phone is None:
		return
	
	if not state.phone_held:
		phone = phone_on_table
		
	phone.setVisible(True)