from audio import Audio
from random import random
from random import randint
from owg.util.Calc import choose

can_show_key = "gregg can show content"
animator = world["GreggAnimator"]
loading_spinner = world["LoadingSpinnerAnimator"]

say = this.say
ask = this.ask
sleep = this.sleep
photo = this.photo

def start():
	if can_show_content():
		animator.show_phone()
	else:
		animator.hide_phone()

def conversation():
	ask("So it's content you're lookin for, huh?", "That's right!")
	say("Well ol' Gregg has got you covered...")
	animator.show_phone()
	animator.hold_phone()
	sleep(1)
	animator.happy()
	say("Just give me one second to find some " + choose("fabulous", "good", "great", "classic", "mouth-watering") + " content.")
	animator.neutral()
	for i in range(randint(1, 3)):
		loading_spinner.on()
		sleep(randint(2, 5))
		loading_spinner.off()
		if random() > 0.75:
			animator.happy()
			say(choose("Ooh,", "Oh,", "Hey,") + " this is pretty " + choose("nice", "good", "great", "cool") + "!")
			animator.neutral()
			say(choose("On second thought, maybe not...", "Nah, nevermind...") + " " + choose("I'll keep looking!", "I'm gonna keep searchin' for content."))
		else:
			say(choose("Oh, it's still loading...", "Still looking--sorry...", "Almost there... Maybe...", "So sorry--still working on it!"))
	loading_spinner.on()
	sleep(5)
	loading_spinner.off()
	say(choose("Oh yeah!", "Yes!", "Aha!") + " I've found the content that you crave!")
	
	if store.addFlag("gregg stinky"):
		stinky()
	elif store.addFlag("gregg dogg"):
		dogg()
	elif store.addFlag("gregg fanart"):
		fanart()
	else:
		choose(stinky, dogg, fanart)()
		
	animator.drop_phone()
	
def stinky():
	photo("stinky.jpg", "GOOD smellin turds")
	animator.happy()
	say("Laughing out loud--yeah this old pic!")
	animator.shocked()
	say("I don't know what you were feeding the 'Doggs that day but they were releasing a WICKED amount of turds.")
	animator.neutral()
	say("And--for a guy like me--a day like that could be summed up in just one Spanish word: \"Bon appetit!\"")
	animator.happy()
	say("Needle-less to say, it was a truly amazing day...")
	animator.neutral()
	sleep(0.5)
	Audio.play("gregg sigh", None, 0.75, None, 1)
	sleep(1.5)
	ask("Hoo! What a trip down memory lane! Thanks for letting me reminisce for a bit.", "Donut mention it")
	
def dogg():
	photo("dogg.jpg", "Hemma Jones--\"Hey Girl!\"")
	animator.happy()
	say("Yep that's her--ol' Hemma Jones. I'd wager that she has the most personality out of the whole flock. But perhaps I'm a bit biased...")
	animator.neutral()
	say("She's not unlike me, you know. She has her own signature digestive properties.")
	say("Like the other 'Doggs in the flock, Hemma Jones is an omnivore--that girl will eat any fruit or turd you give her!")
	animator.shocked()
	say("But what is so unique about her is simply the waste she produces! It defies all biology!")
	animator.neutral()
	say("Turd goes in, a fruit comes out!")
	say("Or one of the Drummer's world-famous Green Turds goes in, and a Weapon comes out!")
	sleep(0.5)
	Audio.play("gregg sigh", None, 0.75, None, 1)
	sleep(1.5)
	say("It's interesting, you know--to see yourself in an animal.")
	ask("We're truly not that far from them.", "Truly.")
	
def fanart():
	say("Check. This. Shit. Out.")
	photo("fanart.png", "Dassdogg fanart!")
	animator.shocked()
	say("I was so shocked when someone reblogged this to me on my Wi-Fi internet, that I immediately downloaded it to a folder-file on my NutzPhone!")
	animator.happy()
	say("I guess there are whole communities dedicated to your flock, Bogus! You're practically famous!")
	animator.neutral()
	ask("I gotta ask--what does it feel like to have fans, Bogus?", "Feels nice.", "Feels fine.", "Feels good.")
	animator.happy()
	say("Laughing out loud! Well, don't let it all go to your head now, sweetie!")
	sleep(0.5)
	animator.neutral()
	Audio.play("gregg sigh", None, 0.75, None, 1)
	sleep(1.5)
	say("Maybe one day I will have my own fanart... But seeing fanart of my favorite flock is pretty fabulous!")
	
def can_show_content():
	return store.hasFlag(can_show_key)
	
def add_show_content():
	return store.addFlag(can_show_key)