from owg.util.euclidian import V2F
from owg.util.data import KryoInstance

state = SimpleNamespace()
state.video_tex_entity = None

state.must_destroy = False
state.must_start = False

state.table_group_offset = V2F()

state.entering = True

decal = world["ForecastSrc"]

initial_decal_state = KryoInstance.kryo(None).copy(decal.state)

decal_target = world["ForecastDst"]
table_decal_group = world["GreggTableGroup"]

# Note: written with the assumption that only one video will be played per conversation with gregg and that gregg can only be spoken to once during a cafe visit

def off():
	state.entering = False
	alarm(apply_off).start(30)
	
def on(video_tex_entity):
	state.video_tex_entity = video_tex_entity
	decal.tex = video_tex_entity.videoTex.tex()
	decal.setVisible(True)
	
def apply_off():
	state.must_destroy = True
		
def step():
	if state.video_tex_entity is not None:
		if state.must_destroy:
			state.must_destroy = False
			state.video_tex_entity.destroy()
			state.video_tex_entity = None
			decal.setVisible(False)
			return
		
		if state.must_start:
			state.must_start = False
		
		# Apply tween
		current = decal.state
		target = decal_target.state if state.entering else initial_decal_state
		current.lerpFrom(current, target, 0.133)

def start():
	decal.setVisible(False)
	decal_target.setVisible(False)