from hubol.util.tex import VideoTexBuilder

from com.jogamp.opengl import GL

from owg.util.euclidian import V2D
from owg.util.Calc import choose

from world.Global import contentRelative

from bogus.core import BogusCore

from hubol.util.tex import VideoTexBuilder

from audio import Audio

clear_skies_light_turd_dusting_video_tex_builder = (VideoTexBuilder(
		BogusCore.egl,
		contentRelative("videos/clear skies light turd dusting.mp4"),
		256,
		256)
		.setMinFilter(True)
		.setMagFilter(True)
		.setLooping(True))
	
heavy_turd_front_video_tex_builder = (VideoTexBuilder(
		BogusCore.egl,
		contentRelative("videos/heavy turd front.mp4"),
		256,
		256)
		.setMinFilter(True)
		.setMagFilter(True)
		.setLooping(True))

say = this.say
ask = this.ask
sleep = this.sleep
video = this.video

gregg = world["GreggAnimator"]
forecast = world["ForecastAnimator"]

def conversation():
	if store.addFlag("first forecast"):
		result = ask("Oh, Bogus! You're a turd chaser too?", "Yes!", "No.")
		if result == "Yes!":
			gregg.happy()
			say("Ha! I knew it! I totally had you pinned for a turd guy!")
		else:
			ask("Oh. So you're just interested in my world-renowned turd forecasts?", "Yep.")
		
		gregg.neutral()
		say("Anyway, let's see what I can pull up on the radar here...")
	else:
		prefix = choose("Ha", "You crack me up", "Well alright", "Oh")
		fug = choose("! So ", "--")
		another = choose("you're in need of", "you're craving") + " another turd forecast" + choose(", eh?", ", huh?")
		
		planning = choose("You must be", "Must be") + " planning something " + choose("pretty ", "") + choose("turd-centric", "important") + choose("!", ", then!")		
		
		gregg.happy()
		say(prefix + fug + another + " " + planning)
		gregg.neutral()
		say(choose(
			choose("Let's", "Let us") + " take a " + choose("peek", "look", "glance") + " at the" + choose(choose(" good", "") + choose(" old", " ol'"), "") + " " + choose("turd-radar", "radar") + "!",
			"Well, let's see what the " + choose("radar", "turd-radar") + " has in store for " +choose("us", "you and me")+ "!"
		))

	forecast_tuple = get_forecast_tuple()

	this.patron.scaleCameraSpeed(2)
	this.patron.setCameraTarget(forecast_camera_pos())
	sleep(0.25)
	
	forecast_tuple[0]()
	
	forecast.off()
	sleep(0.25)
	this.patron.revertCameraTarget()
	sleep(0.5)
	
	forecast_tuple[1]()
	
	this.patron.resetCameraSpeed()

def clear_skies_light_turd_dusting():
	play_forecast(clear_skies_light_turd_dusting_video_tex_builder)
	
	sleep(2)
	gregg.sad()
	sleep(2)
	say("Wow...")
	sleep(1)
	say("This is a pretty rough forecast to see" + choose(", you know", "") + " for a guy like me" + choose(" and all", "") + "...")
	say("I'm afraid to say we're looking at mostly clear skies with only a light turd dusting across the country...")
	
def after_clear_skies_light_turd_dusting():
	say("Wow... it's just hitting me...")
	say("What the heck am I gonna do for food?! I'm gonna really have to make these few turds I have last...")
	ask("Please pray for me, Bogus.", "I will.")
	say("I appreciate that...")
	
def heavy_turd_front():
	play_forecast(heavy_turd_front_video_tex_builder)
	
	sleep(2.3)
	
	if store.addFlag("radar explanation"):
		say("The colors on this radar indicate the rate of Boweled Movements in Dassdoggs over the past twenty-four hours!")
		say("Using this information, I am able to make a decently accurate prediction of the coming days' turd levels!")
		say("So let me take a look here...")
	
	sleep(1)
	gregg.shocked()
	sleep(2)
	gregg.happy()
	sleep(2)
	gregg.neutral()
	say("You see it right, Bogus?")
	sleep(2)
	say("You see all that red on the radar, yeah? That, " +choose("my dear friend", "dear Bogus")+ ", is what we in the turd-storm chasing community call a \"Heavy Turd Front\"!")
	say("We're looking at a " + choose("92", "97", "100") + "% chance of intense winds, " + choose("smells", "aromas") + ", and " + choose("turdage", "turds") + ".")
	say("So there are a couple ways civilization tends to react to this kind of severe turd-weather.")
	say("Guys like me--well, we stay outside the whole time--basking in the sweet grace of the turd-laced countryside!")
	gregg.sad()
	say("While the normies, the fools, and the turd-fearing all shut their blinds and hide away inside...")
	gregg.neutral()
	say("But I think you could handle it, Bogus! Once the eye of the storm is over us, you should come hang out with me--could be pretty cool! Maybe you'd find that turds are your thing!")

def after_heavy_turd_front():
	say("Well that is such exciting stuff!")
	gregg.happy()
	say("I know what I'm doing over the next couple days! Laughing out loud!")
	sleep(0.5)
	gregg.neutral()
	Audio.play("gregg sigh", None, 0.75, None, 1)
	sleep(1.5)
	say("Well I am just so stoked! Anyway, next time you're in dire need of a turd forecast you know where to find me, bud!")
	
def get_forecast_tuple():
	clear_skies = (clear_skies_light_turd_dusting, after_clear_skies_light_turd_dusting)
	heavy_turds = (heavy_turd_front, after_heavy_turd_front)
	
	chosen_forecast = choose([clear_skies, heavy_turds])
	
	if store.addFlag("heavy turd front"):
		chosen_forecast = heavy_turds
	elif store.addFlag("clear_skies_light_turd_dusting"):
		chosen_forecast = clear_skies
	
	return chosen_forecast
	
def forecast_camera_pos():
	camera = world["ForecastCamera"]
	return V2D(camera.getX(), camera.getY())

def play_forecast(video_tex_builder):
	video_tex_entity = video(video_tex_builder, 24)
	if video_tex_entity is None:
		return
	forecast.on(video_tex_entity)