from mini.legs import LegsSpawner
from loc.dmv import DMVSpawner

from owg.util.Calc import choose

ask = this.ask
say = this.say
sleep = this.sleep

meatfiend = world["MeatFiendAnimator"]
sandwich = world["MeatFiendSandwich"]
overworld_sandwich = world["OverworldMeatFiendSandwich"]

def conversation():
	if borgus_bought_goggles() and store.addFlag("discussed borgus new goggles"):
		discuss_borgus_new_goggles()
		set_spoke_once()
	elif bogus_got_license() and has_spoke_once() and store.addFlag("meatfiend discussed license"):
		discuss_bogus_new_license()
	else:
		discuss_normal()
		set_spoke_once()
		
def discuss_borgus_new_goggles():
	ask("Hey Bogus! I saw your brother at the NutzMart convenience store the other day!", "Yeah?")
	say("Yep! It was kind of hard to forget because he just threw a pile of exact change at me.")
	say("He was buying some cool new goggles. They looked good on him I guess.")
	say("I know you two have your issues... Just take it easy on him...")
	meatfiend.shock()
	say("Oh, and if you see him around, you should encourage him to shower! Even the undead need not smell so pitiful!")
	meatfiend.neutral()
	
def discuss_bogus_new_license():
	ask("Oh hey Bogus, I never asked--what's it like being street legal?!", "Amazing.", "Exquisite.", "Luxurious.")
	ask("Ha! I figured! You look like a total bad ass riding around Mundenmark in that sweet truck! What is that, a '96, '97?", "Not sure.")
	meatfiend.shock()
	say("Oh, you're not a big truck-head like your brother, are ya?!")
	meatfiend.neutral()
	say("No, biggie! One per family is usually enough. I'll direct all truck-related questions to the Borg-man...")
	say("See you around, toots!")
	
def discuss_normal():
	greeting = choose("Hey Bogus", "Oh, hey Bogus", "Hiya, Bogus")
	alibi = choose("I'm just here in between shifts", "I'm just enjoying my " + choose("lunch", "dinner") + " break")
	
	message = greeting + choose(".", "!") + " " + alibi + "."
	
	discuss_food_break(message)
			
def discuss_food_break(message):
	ask(message, "Sandwich?")
	
	bogus_requesting_bite = is_bogus_requesting_bite()
	if bogus_requesting_bite:
		bogus_takes_bites()
	
	meatfiend_got_bites = sandwich.has_bites_left()
	
	while sandwich.has_bites_left():
		sandwich.bite(0.025)
		sleep(0.07)
		
	if meatfiend_got_bites:
		say("Mmm mmm! Now that's what I call " + choose("zesty", "tasty", "scrumptious", "yummy") + "!")
		
	overworld_sandwich.setVisible(False)
	
	say("You know... It's like my MeatMama always said...")
	
	cafe_music_player.stop_music()
	
	sleep(0.3)
	spotlight.on()
	
	playback_time_seconds = play_song("try something new.ogg", "try something new.txt")
	sleep(playback_time_seconds - 2)
	spotlight.off()
	sleep(0.67)
	cafe_music_player.play_music()
	sleep(0.67)
	
	say("OK, see you around, Bogus!")
		
def is_bogus_requesting_bite():
	if store.addFlag("discussed sammy once"):
		meatfiend.shock()
		say("Damn! Nice eye! Indeed, that is a Veggie Sammy!")
		meatfiend.neutral()
		
		yes = "Sure."
		result = ask("Would you like to try a bite?", yes, "No, thanks!")
		return result == yes
	
	say("Yep! I'm telling you, it's the best thing this cafe has!")
	
	yes = "Sure!"
	result = ask("Would you like a bite?", yes, "No, thanks!")
	return result == yes
		
def bogus_takes_bites():
		sleep(0.1)
		sandwich.slide_to_bogus(1)
		sleep(1.5)
		sandwich.bite(0.2)
		sleep(0.6)
		
		while True:
			if ask_if_bogus_wants_another_bite():
				sandwich.bite(0.1)
				sleep(0.6)
				
				if not sandwich.has_bites_left():
					if store.addFlag("first time eating whole sammy"):
						say("Oh... I guess my sandwich is gone...")
						say("I hope you enjoyed it...")
					else:
						say("Wow... You ate my whole sandwich again...")
						say("Maybe you should just get your own?")
					break
			else:
				sleep(0.1)
				sandwich.slide_to_meatfiend(1)
				sleep(1.1)
				break
			
def ask_if_bogus_wants_another_bite():
	modifier = choose("pretty", "quite", "really")
	adjective = choose("good", "tasty", "yummy")
	ensure = choose("right", "isn't it", "yeah", "huh")
	
	another_bite = choose(choose("Would you like ", "Do you want ") + "another bite?", "You can have another bite" + choose("!", ", if you like."))
	
	yes = choose("Sure!", "OK!")
	result = ask("It's " + modifier + " " + adjective + ", " + ensure + "? " + another_bite, yes, "No, thanks.")
	
	return result == yes
	
def bogus_got_license():
	return DMVSpawner.license.isAwarded()
	
def borgus_bought_goggles():
	return LegsSpawner.win.isAwarded()

spoke_once_flag = "spoke once meatfiend"
	
def set_spoke_once():
	store.addFlag(spoke_once_flag)
	
def has_spoke_once():
	store.hasFlag(spoke_once_flag)

make_sing = this.makeSing	

def play_song(song_file_name, lyrics_file_name):
	sing = make_sing(song_file_name, lyrics_file_name, lyrics.set_lyric_text, lyrics.clear_lyric_text)
	if sing is None:
		say("Hm... looks like I'm having some technical difficulties...")
		say("Sorry Bogus, maybe next time!")
		return None
	
	playback_time_seconds = sing()
	return playback_time_seconds

lyrics = world["MeatFiendLyricsAnimator"]
spotlight = world["MeatFiendSpotlight"]
cafe_music_player = world["MusicPlayer"]