from audio import Audio
from world import Global

from hubol.entity.HubolEntityPosD import HubolEntityVXD
from hubol.util import AudacityLabelProcessor

from owg.util.editor2d.entity import Ephemeral
from owg.util.euclidian import Compass
from owg.util.euclidian import V2D

from owg.util.opengl import ColorF
from owg.util.opengl import BlendMode
from owg.util.opengl import TextureLib

from owg.util.Calc import fastSin, fastCos, PI

from bogus.core.BogusCore import egl

from java.lang.Math import random

from math import ceil

start_pos = this.state.pos.clone()

def set_lyric_text(lyric):
	lyric_text_renderer.set_text(lyric.text)
	
def clear_lyric_text():
	lyric_text_renderer.clear_text()

class TextRenderer(HubolEntityVXD, Ephemeral):
	def __init__(self, depth, pos):
		HubolEntityVXD.__init__(self, list, depth, pos)
		self.text = ""
		self.steps = 0
		
	def set_text(self, text):
		self.text = text
		
	def clear_text(self):
		self.text = ""

	def renderLerped(self, lerped):
		if len(self.text) == 0:
			return
		
		iterations = 22
		
		delta = self.state.pos.clone().sub(start_pos).len() / iterations
		pos = start_pos.clone()
		font = game.eventFontRenderer;
		
		for i in range(iterations):
			color = colors[1 if i < iterations - 1 else 0]
			font.setColor(color)
			egl.modelviewMatrix().push()
			egl.modelviewMatrix().translated(pos.x(), pos.y(), 0)
			egl.modelviewMatrix().scalef(1.3, 1.3, 1)
			font.render(egl, self.text, 0, 0, Compass.CENTER)
			egl.modelviewMatrix().pop()
			pos.accelerateTowards(self.state.pos, delta)
		
		font.setColor(ColorF.BLACK)
		
	def beginStep(self):
		pass
		
	def step(self):
		x = fastSin(self.steps / 60.0 * PI) * 30.0
		y = fastCos((self.steps + 18.0) / 120.0 * PI) * 30.0
		self.state.pos.set(start_pos).add(x, y)
			
		self.steps = (self.steps + 1.0) % 240.0
		
def get_color(placeable_rectangle):
	return placeable_rectangle.color.get()
		
lyric_text_renderer = TextRenderer(-100, this.state.pos.clone())
colors = map(get_color, [world["MeatFiendFrontColor"], world["MeatFiendBackColor"]])