from audio import Audio

decals = world["MeatFiendSpotlightDecals"]

state = SimpleNamespace()
state.alpha = 1
state.on = True

def set_alpha(decal, alpha):
	decal.color.set(decal.color.get().deriveAlpha(alpha))
	
def on():
	Audio.play("spotlight", None, 1, None, 1)
	state.alpha = 1
	state.on = True
	for decal in decals:
		set_alpha(decal, 1)
		
def off():
	state.on = False

def start():
	state.alpha = 0
	off()
	for decal in decals:
		set_alpha(decal, 0)
	
def step():
	if state.on and state.alpha > 0:
		return
	
	state.alpha = max(0, state.alpha - 0.03)
	
	for decal in decals:
		set_alpha(decal, state.alpha)
		