from java.lang.Math import random
from world import World
from mini.legs import LegsSpawner
from mini.tulips import TulipsSpawner
from mini.track import TrackSpawner
from loc.cafe import CafeSpawner

gregg = world["Gregg \"The Hungry\""]
bobuck = world["Charles Bobuck"]
peter = world["Peter Nuss"]
meatfiend = world["MeatFiend"]
trash_bag = world["Trash Bag"]

tableTopRight = world["TableTopRight"]
tableTopLeft = world["TableTopLeft"]

patrons = [gregg, bobuck, peter, meatfiend, trash_bag]

def start():
	for patron in patrons:
		patron.setEnabled(False)
	
	patrons_count = 0
	apply_top_right = get_apply_top_right_table_patron()
	if apply_top_right is not None:
		apply_top_right()
		patrons_count += 1
	
	if should_apply_bobuck():
		apply_bobuck()
		patrons_count += 1
		
	if should_apply_peter(patrons_count):
		apply_peter()
		patrons_count += 1
		
	if should_apply_trash_bag(patrons_count):
		apply_trash_bag()
		patrons_count += 1

def get_apply_top_right_table_patron():
	if random() < 0.1:
		return None

	should_apply_meatfiend = is_meatfiend_available()
	should_apply_gregg = is_gregg_available()
	
	if should_apply_meatfiend and should_apply_gregg:
		value = random()
		should_apply_meatfiend = value > 0.5
		should_apply_gregg = not should_apply_meatfiend

	if should_apply_meatfiend:
		return apply_meatfiend
	elif should_apply_gregg:
		return apply_gregg
	return None
	
def is_meatfiend_available():
	return World.DMV.hasBeenLoaded() or LegsSpawner.win.isAwarded()
	
def is_gregg_available():
	return World.SHEPHERD.hasBeenLoaded() or TulipsSpawner.winMedal.isAwarded() or TrackSpawner.spokeToGregg.isPresent()
	
def should_apply_bobuck():
	if random() < 0.1:
		return False
	return World.DRUM.hasBeenLoaded() or World.KARAOKE_BOTH.hasBeenLoaded() or World.TULIPS.hasBeenLoaded()
	
def should_apply_peter(patrons_count):
	if random() < 0.125:
		return False
	return patrons_count == 0 or CafeSpawner.getConversationsCompleted() > 2
	
def should_apply_trash_bag(patrons_count):
	return patrons_count == 0 or CafeSpawner.getConversationsCompleted() > 0
	
def apply_gregg():
	tableTopRight.setVisible(False)
	gregg.setEnabled(True)
	gregg.entryScript.get().apply_turds()

def apply_meatfiend():
	tableTopRight.setVisible(False)
	meatfiend.setEnabled(True)
	
def apply_bobuck():
	tableTopLeft.setVisible(False)
	bobuck.setEnabled(True)
	
def apply_peter():
	peter.setEnabled(True)
	
def apply_trash_bag():
	trash_bag.setEnabled(True)