from owg.util.Calc import choose

from java.lang.Math import random
from collections import namedtuple
	
Art = namedtuple('Art', 'filename description conversation')

state = SimpleNamespace()
state.run_away = 0

say = this.say
ask = this.ask
sleep = this.sleep
photo = this.photo

shuffler = world["PeterSlidesAnimator"]

def conversation():
	if store.addFlag("first peter conversation"):
		ask("Whoa, whoa, whoa! Chill out little guy. I realize it's not every day you get to see a local celebrity.", "?")
		say("I know, I know--you're speechless, I get it. Most people have a similar reaction to my work, which you're obviously familiar with.")
		yes = "Sure!"
		result = ask("Speaking of which, perhaps you'd like a copy of one of my pieces. I've brought a lot of rarities with me. I can even autograph it for you.", yes, "No, thanks.")
		if result == yes:
			present_next_art()
		else:
			store.addFlag(peter_hater)
			say("Wow. Wow, wow, wow, wow.")
			say("I think I have to leave.")
			begin_run_away()
			sleep(3)
	elif store.hasFlag(peter_hater):
		say(choose("Oh, ", "Well, well, well, ") + "it's you" + choose(".", " again."))
		yes = "Sure."
		result = ask("So, have you come to your senses yet? Are you ready to appreciate some of my fine art?", yes, "No, thanks.")
		if result == yes:
			store.removeFlag(peter_hater)
			present_next_art()
		else:
			say("Jeez-ows, you're quite the hater you know it? A persistent, miserable hater.")
			begin_run_away()
			sleep(3)
	else:
		adjective = choose("extravagant", "fabulous", "marvelous")
		show_art = False
		if random() > 0.5:
			yes = "Show me!"
			result = ask(choose("Hi", "Hello") + " " + choose("darling", "sweetie") + ", " + choose("did you come to see more " + adjective + " pieces?", "I've got other " + adjective + " pieces I know you're DYING to see."), yes, "No thanks.")
			show_art = result == yes
		else:
			yes = "That's right!"
			result = ask("Well, well, well, looks like someone is hungry for a bit of culture--and only one of my " + adjective + " pieces can " + choose("satiate", "satisfy") + " you!", yes, "Nah.")
			show_art = result == yes
		
		if show_art:
			present_next_art()
		else:
			artist = choose("Van Gogh", "Picasso")
			say("Oh... That's fine. I suppose you need to clear your palette before checking out my work. Maybe go look at a " + artist + " or something?")

def discuss_fish():
	ask("Pretty great right?", "Sure.")
	say("This one was a piece I submitted to the local aquarium. They were requesting bids for a mural.")
	say("Of course, they didn't give me a contract--I suppose my work is just too challenging!")
	
def discuss_pink():
	say("Now this one is a classic.")
	say("I made this during my minimalist phase. I was walking those Mundenmark streets and saw the most lovely can of paint on some denizen's sidewalk.")
	say("So I tried to recreate the paint color digitally. It took days to pick the Red value. The Green and Red each took an additional day.")
	say("I'm not sure that it totally translates, really. But I still think it's a great piece.")
	say("Maybe I could sell it to a paint company... Now there's an idea!")
	
def discuss_hermit():
	ask("Hey slick, have you ever seen the wonderful film trilogy \"Harry Potter\"?", "Yes.", "Of course.")
	say("Well color me surprised! It's a pretty intellectual film, darling. Kudos for watching it!")
	say("Anyway, I had just come back from the showing of \"Harry's Potter\". As you know there are many witches, warlocks, etc. in the film.")
	say("And the characters all wore such fabulous hats--oh, those hats! I just had to create an image focusing on the hats!")
	say("And this was the result--just a hermited wizard, too anxious to leave the home!")
	say("Yeah, it's a real thinker.")
	
def discuss_florist():
	say("Look, look, look--I'll be the first to admit.")
	say("This isn't my best work, alright. I'm actually not sure why I've got it with me...")
	say("I'm just not convinced that it's doing anything interesting, I'll be sure to dig up something more stimulating for next time.")
	
def discuss_desert():
	say("Now I think this is a powerful piece!")
	say("On the outskirts of town there are many patchy, decaying acres of land--presumably from deforestation, darling.")
	say("I wanted to make a statement by juxtaposing the barren land with piles of my extravagant dishware.")
	say("I'm truly a pioneer, darling. Environmental campaigns call me everyday--begging me to part with my piece for huge sums of money!")
	say("But I don't belong in the leagues of politicians! Truly, I'm just a regular simpleton like yourself!")
	say("Look--I even go to cafes!")
	
def discuss_extraterrestrial():
	say("Aliens. The final frontier.")
	say("You know about extraterrestrials, right? They're basically just humans with some food dye and balloon heads.")
	say("I was riding in my tour bus for one of my talk-tours a year or so ago. The television on the bus was stuck on the sci-fi channel.")
	say("As I was fading in and out of consciousness (touring is very exhausting for me), I was having very vivid dreams about extraterrestrial life.")
	say("After this experience, I immediately canceled the tour. We turned the bus right around. I didn't sleep for a month. I was working on this piece the whole time.")
	say("I've got the artist bug--what can I say!")
	
def discuss_gambler():
	ask("Say, have you been to the casino?", "Yea.", "Nea.")
	say("Right. Anyway, I've got a couple of friends who are always asking me to go down to the casino with them.")
	say("Every now and then I cave and we go down to play the slots for a while.")
	say("The casino sits on the most picturesque hill, and every time I go I have always thought about how I need to create a piece incorporating the hill!")
	say("Anyhow, the last time they invited me to the casino, I conveniently had just completed a shoot (for charity) and had my tripod with me!")
	say("So when I arrived, my friend and I posed together on the hillside. As soon as I had the film developed I knew the piece required no augmentation.")
	say("Raw. Powerful. That's art, baby.")
	
def discuss_pedestal():
	ask("Have you ever felt like you're being put on a pedestal?", "Yea.", "Nea.")
	say("It's a strange feeling... My fans truly think the very highest of me.")
	say("And that was what I was trying to capture with this piece. It's like all eyes are on me, you know?")
	say("It's a personal work, darling, a personal work.")
	
def discuss_party():
	say("You know, there's this fabulous, educated guy who lives right here in town who throws the greatest parties!")
	say("Maybe you've heard of him--Gregg \"The Hungry\"? He's quite the character--He's a unique guy with an even more unique appetite!")
	say("Anyhow, when I saw the buffet of appetizers he had I simply had to document it! Such colorful cuisine!")
	say("Cultured folk are my folk!")
	
fish = Art("fish.jpg", "Fish", discuss_fish)
pink = Art("pink.jpg", "Pink", discuss_pink)
hermit = Art("hermit.jpg", "Hermit", discuss_hermit)
florist = Art("florist.jpg", "Florist", discuss_florist)
desert = Art("desert.jpg", "Desert", discuss_desert)
extraterrestrial = Art("extraterrestrial.jpg", "Extraterrestrial", discuss_extraterrestrial)
gambler = Art("gambler.jpg", "Gambler", discuss_gambler)
pedestal = Art("pedestal.jpg", "Pedestal", discuss_pedestal)
party = Art("party.jpg", "Party", discuss_party)

arts = [ fish, pink, hermit, florist, desert, extraterrestrial, gambler, pedestal, party ]
		
def present_next_art():
	art = choose_next_art()
	present_art(art)
		
def choose_next_art():
	for art in arts:
		if store.addFlag(art.filename):
			return art
	return choose(arts)
		
def present_art(art):
	shuffler.on()
	sleep(1.55)
	shuffler.off()
	say(choose("Behold!", "Ta-da!"))
	photo(art.filename, art.description)
	art.conversation()
	
run_away = world["PeterRunAway"]

def begin_run_away():
	state.run_away = 256
	
def step():
	if state.run_away <= 0:
		return
	state.run_away -= 1
	for entity in run_away:
		entity.state.pos.add(-4, 0)
		
peter_hater = "peter hater"