from owg.util.Calc import fastSin, fastCos, PI
from audio.Audio import play

state = SimpleNamespace()
state.inspected = False
state.steps = 0.0

class Decal:
	def __init__(self, decal):
		self.decal = decal
		self.initial_scale = decal.state.scale.clone()
		
	def set_scale(self, xscale, yscale):
		self.decal.state.scale.set(self.initial_scale).multiply(xscale, yscale)
		
	def set_subimage(self, subimage):
		self.decal.subimage.set(subimage)

decals = map(Decal, world["TrashBagGroup"])
		
def inspect():
	state.inspected = True
	for decal in decals:
		decal.set_subimage(1)
	play("trash bag open", None, 1, None, 1)

def step():
	xscale = 1 + fastCos((state.steps % 60.0) / 30.0 * PI ) * (0.0125 if state.inspected else 0.025)
	yscale = 1 + fastSin((state.steps + 45.0) / 60.0 * PI ) * (0.0163 if state.inspected else 0.0325)
		
	for decal in decals:
		decal.set_scale(xscale, yscale)
		
	state.steps = (state.steps + 1.0) % 120.0