from mini.shepherd import ShepherdSpawner
from owg.util.Calc import choose

from owg.util.euclidian import V2D

say = this.say
ask = this.ask
script = this.script

gregg = world["GreggAnimator"]

arrow = world["TurdArrowAnimator"]

show_content_script = world["GreggContent"]
killed_all_script = world["GreggScoldKilledAll"]

def conversation():
	if should_scold_for_killed_all():
		script(killed_all_script)
	elif should_scold_for_killed_half():
		script(world["GreggScoldKilledHalf"])
	else:		
		primary()

def primary():
	pre = choose("It's just", "Just", "Ah,", "Oh,")
	mundenmark = choose(choose("beautiful", "wonderful", "good ol'", "magnificent", "fabulous") + " Mundenmark", "Mundenmark")
	punctuation = choose(".", "!")
	
	say(pre + " another day in " + mundenmark + punctuation)
	if store.addFlag("gregg explained turds on floor"):
		gregg.happy()
		say("I just love coming into town! There's so much to do and see!")
		gregg.neutral()
		say("And I get such great cellular service when I'm out of the countryside!")
		ask("And, you know, even though this cafe doesn't serve turds to ol' turd-hounds like me, I've got a way to keep fed!", "What is it?")
		say("Well take a look down here...")
		this.patron.setCameraTarget(turd_zoom_pos())
		arrow.enable()
		this.sleep(3)
		arrow.disable()
		this.patron.revertCameraTarget()
		gregg.happy()
		say("It's a classic trick... If a restaurant doesn't serve your favorite food, simply bring your own food inside!")
		gregg.neutral()
		ask("In my experience, this method works best at cafes, since you don't have a server coming over to your table.", "Nice!", "Cool!")
		say("Yeah, let me know if you need any other tips--I'm a pretty well-traveled guy.")
	else:
		interesting = "What's up?"
		forecast = "Turd forecast?"
		content = "Any content?"
		
		result = None
		
		if show_content_script.can_show_content():
			result = ask(greeting_question_message(), interesting, content, forecast)
		else:
			result = ask(greeting_question_message(), interesting, forecast)
			
		if result == interesting:
			script(world["GreggWhatsUp"])
		elif result == content:
			script(show_content_script)
		else:
			script(world["GreggTurdForecast"])
			
def greeting_question_message():
	return choose("Well...", "Well!", "Well then...") + " " + choose("What do you wanna know" + choose("?", " about?"), "What can I do for you?")
			
def turd_zoom_pos():
	turdZoom = world["TurdZoom"]
	return V2D(turdZoom.getX(), turdZoom.getY())
		
def should_scold_for_killed_all():
	return not store.hasFlag("killed all - forgiven by gregg") and ShepherdSpawner.killedAll.isPresent()
	
def should_scold_for_killed_half():
	return not store.hasFlag("killed all - forgiven by gregg") and not store.hasFlag("killed half - forgiven by gregg") and ShepherdSpawner.killedHalf.isPresent()
	
def apply_turds():
	if not should_scold_for_killed_all():
		return
	turds = killed_all_script.get_turd_amount()
	if turds < 3:
		world["Turd3"].setVisible(False)
	if turds < 2:
		world["Turd2"].setVisible(False)
	if turds < 1:
		world["Turd1"].setVisible(False)
	